/*

    Zelda Time to Triumph

    Copyright (C) 2007-2024  Vincent Jouillat

    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#ifndef __ENNEMI095_H__
#define __ENNEMI095_H__

#include "../../../engine/resources/WImage.h"

#include "../../../engine/util/time/Chrono.h"

#include "../types/Ennemi.h"

class Ennemi095 : public Ennemi {
    public :
        Ennemi095(int x, int y);
        ~Ennemi095();

        void ennLoop();
        void draw(int offsetX, int offsetY);

        int getX();
        int getY();

        BoundingBox* getBoundingBox();

        void reset();
        bool isResetable();

        bool hasEffect(TypeAttack type, TypeEffect effect, Direction dir);

    protected :

        void afterHit();

    private :

        void moveX(int dx);

        int anim;
        int animMax;
        int vanim;

        int step;

        WImage* image;

        Chrono chrono;

        BoundingBox box;
};

#endif  // Ennemi095.h
